Attribute VB_Name = "Settings"
Option Explicit

Dim nrOfSettings As Integer
Dim keys() As String
Dim settings() As String

Sub SaveSettings()
    Dim f As Integer
    f = FreeFile
    If Dir$(App.path & "\settings.dat") <> "" Then
        Kill App.path & "\settings.dat"
    End If
    Open App.path & "\settings.dat" For Binary As #f
        Put #f, , nrOfSettings
        Put #f, , keys
        Put #f, , settings
    Close #f
End Sub

Sub LoadSettings()
    If Dir$(App.path & "\settings.dat") = "" Then
        nrOfSettings = 0
        ReDim keys(0)
        ReDim settings(0)
        Exit Sub
    End If

    Dim f As Integer
    f = FreeFile
    Open App.path & "\settings.dat" For Binary As #f
        Get #f, , nrOfSettings
        ReDim keys(nrOfSettings)
        ReDim settings(nrOfSettings)
        Get #f, , keys
        Get #f, , settings
    Close #f
End Sub

Function GetSetting(key As String, Optional defaultval As Variant = vbNullString) As String
    Dim index As Integer
    index = getSettingIndex(key)
    
    If index = -1 Then
        GetSetting = defaultval
    Else
        GetSetting = settings(index)
    End If
End Function

Sub SetSetting(key As String, value As String)
    Dim index As Integer
    index = getSettingIndex(key)
    
    If index = -1 Then
        Call CreateSetting(key, value)
    Else
        settings(index) = value
    End If
End Sub

Private Sub CreateSetting(key As String, value As String)
    ReDim Preserve settings(UBound(settings) + 1)
    ReDim Preserve keys(UBound(keys) + 1)
    settings(UBound(settings)) = value
    keys(UBound(keys)) = key & ":" & UBound(settings)
    nrOfSettings = nrOfSettings + 1
End Sub

Sub RemoveSetting(key As String)
    Dim index As Integer
    index = getSettingIndex(key)
    
    If index = -1 Then
        'no entry to be removed
    Else
        Call RemoveKey(key)
        
        Dim j As Integer
        'move all other settings
        For j = index To UBound(settings) - 1
            settings(j) = settings(j + 1)
        Next
        'remove the last setting,empty setting, by shrinking the array
        ReDim Preserve settings(UBound(settings) - 1)
        nrOfSettings = nrOfSettings - 1
    End If
End Sub

Private Sub RemoveKey(key As String)
    Dim i As Integer
    Dim index As Integer
    index = -1
    For i = 0 To UBound(keys)
        Dim parts() As String
        parts = Split(keys(i), ":")
        If LCase(parts(0)) = LCase(key) Then
            index = i
            Exit For
        End If
    Next
    
    If index = -1 Then
        'no key found
    Else
        Dim j As Integer
        'move all other keys
        For j = index To UBound(keys) - 1
            keys(j) = keys(j + 1)
        Next
        'remove the last key by shrinking the array
        ReDim Preserve keys(UBound(keys) - 1)
    End If
End Sub

Private Function getSettingIndex(key As String)
    Dim i As Integer
    For i = 0 To UBound(keys)
        If keys(i) <> "" Then
            Dim parts() As String
            parts = Split(keys(i), ":")
            If parts(0) = key Then
                getSettingIndex = CInt(parts(1))
                Exit Function
            End If
        End If
    Next
    
    'the for didn't find the key, so it doesn't exist
    getSettingIndex = -1
End Function
