Attribute VB_Name = "SharedVar"
Option Explicit

'true if mouse if down on tileset/map/radar
Global MouseDown As Boolean

Global bDEBUG As Boolean

Global Const TileW = 16
Global Const TileH = 16

Global tick As Long

Global clipdata() As Integer
Global clipBoundaries As RECT
Global clipBitField() As Boolean
Global clipHasData As Boolean

Type RECT
    Left As Integer
    Right As Integer
    Top As Integer
    Bottom As Integer
End Type

Enum toolenum
    T_magnifier = 1
    T_selection
    T_magicwand
    T_hand
    T_pencil
    T_dropper
    T_Eraser
    T_airbrush
    T_bucket
    T_line
    t_spline
    T_rectangle
    T_ellipse
    T_filledrectangle
    T_filledellipse
End Enum

Global splineInProgress As Boolean
Global curtool As toolenum

Function TilePixelColor(tileval As Integer) As Long
    Select Case tileval
    Case 0 'empty
      TilePixelColor = vbBlack
    Case -1 ' special case, for bigger special tiles
      TilePixelColor = vbMagenta
    Case 1 To 161 'normal
      TilePixelColor = RGB(192, 192, 192)
    Case 162 To 165 'Vdoor
      TilePixelColor = vbBlue 'RGB(255, 0, 255)
    Case 166 To 169 'Hdoor
      TilePixelColor = vbBlue 'RGB(255, 0, 255)
    Case 170 'flag
      TilePixelColor = vbYellow
    Case 171 'safe
      TilePixelColor = vbGreen
    Case 172 'soccer
      TilePixelColor = vbRed
    Case 173 To 175 'flyover
      TilePixelColor = vbCyan
    Case 176 To 190 'flyunder
      TilePixelColor = vbCyan
    Case 191 To 215
      TilePixelColor = vbMagenta
    Case 216 'sasteroid1
      TilePixelColor = vbMagenta
    Case 217 'lasteroid
      TilePixelColor = vbMagenta
    Case 218 'sasteroid2
      TilePixelColor = vbMagenta
    Case 219 'starport
      TilePixelColor = vbMagenta
    Case 220 'wormhole
      TilePixelColor = vbMagenta
    Case 221 To 255
      TilePixelColor = vbMagenta
    Case Else 'invalid
      TilePixelColor = vbBlack
  End Select
End Function

Function TilesetToolTipText(tilenr As Integer) As String
    Select Case tilenr
    
    Case 20
        TilesetToolTipText = "Tile " & tilenr & ": Used for map border"
    Case 162 To 165
        TilesetToolTipText = "Tile " & tilenr & ": Door A"
    Case 166 To 169
        TilesetToolTipText = "Tile " & tilenr & ": Door B"
    Case 170
        TilesetToolTipText = "Tile " & tilenr & ": Flag (for turf-style only)"
    Case 171
        TilesetToolTipText = "Tile " & tilenr & ": Safety zone"
    Case 172
        TilesetToolTipText = "Tile " & tilenr & ": Goal tile"
    Case 173 To 175
        TilesetToolTipText = "Tile " & tilenr & ": Fly over tile"
    Case 176 To 190
        TilesetToolTipText = "Tile " & tilenr & ": Fly under tile"
    Case 191
        TilesetToolTipText = "Tile " & tilenr & ": Invisible on screen, Visible on radar, Ships can go through them, Items bounce off it, Thors go through it. (if you fire an item while in it, the item will float suspended in space)"
    Case 192 To 215
        TilesetToolTipText = "Tile " & tilenr & ": Invisible on screen, Visible on radar, Solid block (like any other tile)"
    Case 216
        TilesetToolTipText = "Tile " & tilenr & ": Small asteroid #1"
    Case 217
        TilesetToolTipText = "Tile " & tilenr & ": Large asteroid"
    Case 218
        TilesetToolTipText = "Tile " & tilenr & ": Small asteroid #2"
    Case 219
        TilesetToolTipText = "Tile " & tilenr & ": Space station"
    Case 220
        TilesetToolTipText = "Tile " & tilenr & ": Wormhole"
    Case 221 To 240
        TilesetToolTipText = "Tile " & tilenr & ": Invisible on screen, Visible on radar, Solid block (like any other tile)"""
    Case 241
        TilesetToolTipText = "Tile " & tilenr & ": nvisible on screen, Visible on radar, Ship can go through it but Items dissapear when they touch it."
    Case 242
        TilesetToolTipText = "Tile " & tilenr & ": Invisible on screen, Invisible on radar, Warps your ship on contact, items bounce off it, Thors dissapear on contact"
    Case 243 To 251
        TilesetToolTipText = "Tile " & tilenr & ": Invisible on screen, Invisible on radar, Solid block (like any other tile)"
    Case 252
        TilesetToolTipText = "Tile " & tilenr & ": Visible on screen (Animated enemy brick), Invisible on radar, Items go through it, your ship gets warped after a random amount of time (0-2 seconds) while floating on it."
    Case 253
        TilesetToolTipText = "Tile " & tilenr & ": Visible on screen (Animated team brick), Invisible on radar, Items go through it, so does your ship."
    Case 254
        TilesetToolTipText = "Tile " & tilenr & ": Invisible on screen, Invisible on radar. It is impossible to lay bricks while on/near it. Can be used to limit greens spawning area."
    Case 255
        TilesetToolTipText = "Tile " & tilenr & ": Visible On screen (Animated green prize), Invisible on radar, Items go through it, so does your ship. It doesn't show up on radar, you can't pick it up."
    Case 256
        TilesetToolTipText = "Tile 0: Eraser"
    Case 257 To 258
        TilesetToolTipText = ""
    Case 259 To 266
        TilesetToolTipText = "WallTile set #" & tilenr - 259
    Case Is > 266
        TilesetToolTipText = ""
    Case Else
        TilesetToolTipText = "Tile " & tilenr
    End Select
End Function


Function isTileSpecial(map As frmMain, X As Integer, Y As Integer)
    If Not (X < 0 Or Y < 0 Or X > 1023 Or Y > 1023) Then
        If map.getTile(X, Y) <> 217 And map.getTile(X, Y) <> 219 And _
           map.getTile(X, Y) <> 220 And map.getTile(X, Y) <> -1 Then
            isTileSpecial = False
        Else
            isTileSpecial = True
        End If
    End If
End Function

Function isSelTileSpecial(sel As Selection, X As Integer, Y As Integer)
    If Not (X < 0 Or Y < 0 Or X > 1023 Or Y > 1023) Then
        If sel.getSelTile(X, Y) <> 217 And sel.getSelTile(X, Y) <> 219 And _
           sel.getSelTile(X, Y) <> 220 And sel.getSelTile(X, Y) <> -1 Then
            isSelTileSpecial = False
        Else
            isSelTileSpecial = True
        End If
    End If
End Function

Function GetRED(ByVal RGBColor As Long) As Long
GetRED = RGBColor And &HFF&
End Function

'get the green value from a long
Function GetGREEN(ByVal RGBColor As Long) As Long
GetGREEN = (RGBColor And &HFF00&) \ &H100&
End Function

'get the blue value from a long
Function GetBLUE(ByVal RGBColor As Long) As Long
GetBLUE = (RGBColor And &HFF0000) \ &H10000
End Function

