VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "WallTiles"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim parent As frmMain

Dim walltiles() As Integer

Dim convert(7) As Boolean

Public curwall As Integer
Public UsingWalltiles As Boolean

Private Sub Class_Initialize()
    ReDim walltiles(7, 15) As Integer
    curwall = 0
    GetConvertSettings
End Sub

Sub setParent(main As frmMain)
    Set parent = main
End Sub

Function getWallTile(wallset As Integer, walltile As Integer) As Integer
    getWallTile = walltiles(wallset, walltile)
End Function

Sub setWallTile(wallset As Integer, walltile As Integer, tilenr As Integer)
    walltiles(wallset, walltile) = tilenr
End Sub

Function tileconvert(tile As Integer)
'Converts tile position to walltile number
    Select Case tile
        Case 0
            tileconvert = 9
        Case 1
            tileconvert = 13
        Case 2
            tileconvert = 12
        Case 3
            tileconvert = 8
        Case 4
            tileconvert = 11
        Case 5
            tileconvert = 15
        Case 6
            tileconvert = 14
        Case 7
            tileconvert = 10
        Case 8
            tileconvert = 3
        Case 9
            tileconvert = 7
        Case 10
            tileconvert = 6
        Case 11
            tileconvert = 2
        Case 12
            tileconvert = 1
        Case 13
            tileconvert = 5
        Case 14
            tileconvert = 4
        Case 15
            tileconvert = 0
    End Select
End Function

Sub clearWallTile(wallset As Integer)
Dim i As Integer
    For i = 0 To 15
        walltiles(wallset, i) = 0
    Next
End Sub

Sub SetCurwall(newcurwall As Integer)
    curwall = newcurwall
End Sub

Sub GetConvertSettings()
Dim i As Integer
    For i = 0 To 7
        convert(i) = CBool(GetSetting("Walltile" & i, "0"))
    Next
End Sub

Function IsValidTileforWall(tilenr As Integer) As Boolean
    If tilenr = 0 Or tilenr = 217 Or tilenr = 219 Or tilenr = 220 Or tilenr = -1 Or _
        (convert(0) = False And tilenr >= 173 And tilenr <= 175) Or _
        (convert(1) = False And tilenr >= 176 And tilenr <= 190) Or _
        (convert(2) = False And tilenr = 172) Or _
        (convert(3) = False And tilenr = 170) Or _
        (convert(4) = False And tilenr >= 162 And tilenr <= 169) Or _
        (convert(5) = False And tilenr = 171) Or _
        (convert(6) = False And (tilenr >= 221 Or (tilenr >= 191 And tilenr <= 215))) Or _
        (convert(7) = False And (tilenr = 216 Or tilenr = 218)) Then
        IsValidTileforWall = False
    Else
        IsValidTileforWall = True
    End If
End Function

Sub SaveWallTiles(path As String)
    On Error GoTo errh
    
    If Dir$(path) <> "" Then
        Kill path
    End If
    
    Dim f As Integer
    f = FreeFile
    Open path For Binary As #f
        Put #f, , walltiles
    Close #f
Exit Sub
errh:
    MsgBox "Error: " & Err & " " & Err.Description
End Sub

Sub LoadWallTiles(path As String)
    On Error GoTo errh
    Dim f As Integer
    f = FreeFile
    Open path For Binary As #f
        Get #f, , walltiles
    Close #f
    
Exit Sub
errh:
    MsgBox "Error: " & Err & " " & Err.Description
End Sub



Function DrawWallTile(X As Integer, Y As Integer) As Integer
    Dim val As Integer
    Dim tmp As Integer
    val = 0
    If IsValidTileforWall(parent.getTile(X + 1, Y)) Then val = val + 1
    If IsValidTileforWall(parent.getTile(X, Y - 1)) Then val = val + 2
    If IsValidTileforWall(parent.getTile(X - 1, Y)) Then val = val + 4
    If IsValidTileforWall(parent.getTile(X, Y + 1)) Then val = val + 8
    tmp = parent.walltiles.getWallTile(parent.walltiles.curwall, val)
    If tmp <> 0 Then
        DrawWallTile = tmp
    Else
        DrawWallTile = parent.getTile(X, Y)
    End If
End Function

